# Requires: npm i -g @infinite_dev/cli && export INFINITE_API_KEY=sk_sandbox_...
# Escape hatch for any endpoint: infinite api <METHOD> <path>
infinite api POST /v1/external-wallets \
--body '<request-json>'Create an external wallet.
# Infinite MCP is read-only for this endpoint — use a dedicated MCP tool when one exists, otherwise run the CLI tab.import requests
url = "https://sandbox.api.infinite.dev/v1/external-wallets"
payload = {
"customerId": "cust_abc123",
"walletAddress": "0x1234567890abcdef1234567890abcdef12345678",
"counterpartyId": "cp_abc123",
"chains": ["ETHEREUM", "BASE"],
"currencies": ["USDC", "USDT"],
"externalReference": "550e8400-e29b-41d4-a716-446655440000",
"isThirdParty": False,
"custodyType": "SELF_HOSTED",
"metadata": { "nickname": "Primary USDC Wallet" },
"beneficiaryType": "INDIVIDUAL",
"beneficiaryName": "Jane Doe"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
customerId: 'cust_abc123',
walletAddress: '0x1234567890abcdef1234567890abcdef12345678',
counterpartyId: 'cp_abc123',
chains: ['ETHEREUM', 'BASE'],
currencies: ['USDC', 'USDT'],
externalReference: '550e8400-e29b-41d4-a716-446655440000',
isThirdParty: false,
custodyType: 'SELF_HOSTED',
metadata: {nickname: 'Primary USDC Wallet'},
beneficiaryType: 'INDIVIDUAL',
beneficiaryName: 'Jane Doe'
})
};
fetch('https://sandbox.api.infinite.dev/v1/external-wallets', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://sandbox.api.infinite.dev/v1/external-wallets",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'customerId' => 'cust_abc123',
'walletAddress' => '0x1234567890abcdef1234567890abcdef12345678',
'counterpartyId' => 'cp_abc123',
'chains' => [
'ETHEREUM',
'BASE'
],
'currencies' => [
'USDC',
'USDT'
],
'externalReference' => '550e8400-e29b-41d4-a716-446655440000',
'isThirdParty' => false,
'custodyType' => 'SELF_HOSTED',
'metadata' => [
'nickname' => 'Primary USDC Wallet'
],
'beneficiaryType' => 'INDIVIDUAL',
'beneficiaryName' => 'Jane Doe'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://sandbox.api.infinite.dev/v1/external-wallets"
payload := strings.NewReader("{\n \"customerId\": \"cust_abc123\",\n \"walletAddress\": \"0x1234567890abcdef1234567890abcdef12345678\",\n \"counterpartyId\": \"cp_abc123\",\n \"chains\": [\n \"ETHEREUM\",\n \"BASE\"\n ],\n \"currencies\": [\n \"USDC\",\n \"USDT\"\n ],\n \"externalReference\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"isThirdParty\": false,\n \"custodyType\": \"SELF_HOSTED\",\n \"metadata\": {\n \"nickname\": \"Primary USDC Wallet\"\n },\n \"beneficiaryType\": \"INDIVIDUAL\",\n \"beneficiaryName\": \"Jane Doe\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://sandbox.api.infinite.dev/v1/external-wallets")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"customerId\": \"cust_abc123\",\n \"walletAddress\": \"0x1234567890abcdef1234567890abcdef12345678\",\n \"counterpartyId\": \"cp_abc123\",\n \"chains\": [\n \"ETHEREUM\",\n \"BASE\"\n ],\n \"currencies\": [\n \"USDC\",\n \"USDT\"\n ],\n \"externalReference\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"isThirdParty\": false,\n \"custodyType\": \"SELF_HOSTED\",\n \"metadata\": {\n \"nickname\": \"Primary USDC Wallet\"\n },\n \"beneficiaryType\": \"INDIVIDUAL\",\n \"beneficiaryName\": \"Jane Doe\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://sandbox.api.infinite.dev/v1/external-wallets")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"customerId\": \"cust_abc123\",\n \"walletAddress\": \"0x1234567890abcdef1234567890abcdef12345678\",\n \"counterpartyId\": \"cp_abc123\",\n \"chains\": [\n \"ETHEREUM\",\n \"BASE\"\n ],\n \"currencies\": [\n \"USDC\",\n \"USDT\"\n ],\n \"externalReference\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"isThirdParty\": false,\n \"custodyType\": \"SELF_HOSTED\",\n \"metadata\": {\n \"nickname\": \"Primary USDC Wallet\"\n },\n \"beneficiaryType\": \"INDIVIDUAL\",\n \"beneficiaryName\": \"Jane Doe\"\n}"
response = http.request(request)
puts response.read_body{
"id": "ewa_1234567890abcdef",
"customerId": "cust_abc123",
"type": "EXTERNAL_WALLET",
"status": "IN_REVIEW",
"walletAddress": "0x1234567890abcdef1234567890abcdef12345678",
"addressType": "EVM",
"createdAt": "2026-01-15T10:00:00Z",
"updatedAt": "2026-01-15T10:00:00Z",
"counterpartyId": "cp_abc123",
"metadata": {
"nickname": "Main Checking Account",
"purpose": "Business operations",
"tags": [
"primary",
"operations"
]
},
"chains": [
"ETHEREUM",
"BASE"
],
"currencies": [
"USDC",
"USDT"
],
"custodyType": "SELF_HOSTED",
"created": true
}Create an external wallet
Create an external wallet for a customer. This is an asynchronous flow.
# Requires: npm i -g @infinite_dev/cli && export INFINITE_API_KEY=sk_sandbox_...
# Escape hatch for any endpoint: infinite api <METHOD> <path>
infinite api POST /v1/external-wallets \
--body '<request-json>'Create an external wallet.
# Infinite MCP is read-only for this endpoint — use a dedicated MCP tool when one exists, otherwise run the CLI tab.import requests
url = "https://sandbox.api.infinite.dev/v1/external-wallets"
payload = {
"customerId": "cust_abc123",
"walletAddress": "0x1234567890abcdef1234567890abcdef12345678",
"counterpartyId": "cp_abc123",
"chains": ["ETHEREUM", "BASE"],
"currencies": ["USDC", "USDT"],
"externalReference": "550e8400-e29b-41d4-a716-446655440000",
"isThirdParty": False,
"custodyType": "SELF_HOSTED",
"metadata": { "nickname": "Primary USDC Wallet" },
"beneficiaryType": "INDIVIDUAL",
"beneficiaryName": "Jane Doe"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
customerId: 'cust_abc123',
walletAddress: '0x1234567890abcdef1234567890abcdef12345678',
counterpartyId: 'cp_abc123',
chains: ['ETHEREUM', 'BASE'],
currencies: ['USDC', 'USDT'],
externalReference: '550e8400-e29b-41d4-a716-446655440000',
isThirdParty: false,
custodyType: 'SELF_HOSTED',
metadata: {nickname: 'Primary USDC Wallet'},
beneficiaryType: 'INDIVIDUAL',
beneficiaryName: 'Jane Doe'
})
};
fetch('https://sandbox.api.infinite.dev/v1/external-wallets', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://sandbox.api.infinite.dev/v1/external-wallets",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'customerId' => 'cust_abc123',
'walletAddress' => '0x1234567890abcdef1234567890abcdef12345678',
'counterpartyId' => 'cp_abc123',
'chains' => [
'ETHEREUM',
'BASE'
],
'currencies' => [
'USDC',
'USDT'
],
'externalReference' => '550e8400-e29b-41d4-a716-446655440000',
'isThirdParty' => false,
'custodyType' => 'SELF_HOSTED',
'metadata' => [
'nickname' => 'Primary USDC Wallet'
],
'beneficiaryType' => 'INDIVIDUAL',
'beneficiaryName' => 'Jane Doe'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://sandbox.api.infinite.dev/v1/external-wallets"
payload := strings.NewReader("{\n \"customerId\": \"cust_abc123\",\n \"walletAddress\": \"0x1234567890abcdef1234567890abcdef12345678\",\n \"counterpartyId\": \"cp_abc123\",\n \"chains\": [\n \"ETHEREUM\",\n \"BASE\"\n ],\n \"currencies\": [\n \"USDC\",\n \"USDT\"\n ],\n \"externalReference\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"isThirdParty\": false,\n \"custodyType\": \"SELF_HOSTED\",\n \"metadata\": {\n \"nickname\": \"Primary USDC Wallet\"\n },\n \"beneficiaryType\": \"INDIVIDUAL\",\n \"beneficiaryName\": \"Jane Doe\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://sandbox.api.infinite.dev/v1/external-wallets")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"customerId\": \"cust_abc123\",\n \"walletAddress\": \"0x1234567890abcdef1234567890abcdef12345678\",\n \"counterpartyId\": \"cp_abc123\",\n \"chains\": [\n \"ETHEREUM\",\n \"BASE\"\n ],\n \"currencies\": [\n \"USDC\",\n \"USDT\"\n ],\n \"externalReference\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"isThirdParty\": false,\n \"custodyType\": \"SELF_HOSTED\",\n \"metadata\": {\n \"nickname\": \"Primary USDC Wallet\"\n },\n \"beneficiaryType\": \"INDIVIDUAL\",\n \"beneficiaryName\": \"Jane Doe\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://sandbox.api.infinite.dev/v1/external-wallets")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"customerId\": \"cust_abc123\",\n \"walletAddress\": \"0x1234567890abcdef1234567890abcdef12345678\",\n \"counterpartyId\": \"cp_abc123\",\n \"chains\": [\n \"ETHEREUM\",\n \"BASE\"\n ],\n \"currencies\": [\n \"USDC\",\n \"USDT\"\n ],\n \"externalReference\": \"550e8400-e29b-41d4-a716-446655440000\",\n \"isThirdParty\": false,\n \"custodyType\": \"SELF_HOSTED\",\n \"metadata\": {\n \"nickname\": \"Primary USDC Wallet\"\n },\n \"beneficiaryType\": \"INDIVIDUAL\",\n \"beneficiaryName\": \"Jane Doe\"\n}"
response = http.request(request)
puts response.read_body{
"id": "ewa_1234567890abcdef",
"customerId": "cust_abc123",
"type": "EXTERNAL_WALLET",
"status": "IN_REVIEW",
"walletAddress": "0x1234567890abcdef1234567890abcdef12345678",
"addressType": "EVM",
"createdAt": "2026-01-15T10:00:00Z",
"updatedAt": "2026-01-15T10:00:00Z",
"counterpartyId": "cp_abc123",
"metadata": {
"nickname": "Main Checking Account",
"purpose": "Business operations",
"tags": [
"primary",
"operations"
]
},
"chains": [
"ETHEREUM",
"BASE"
],
"currencies": [
"USDC",
"USDT"
],
"custodyType": "SELF_HOSTED",
"created": true
}Authorizations
API Key in Bearer format (e.g., Bearer sk_test_...)
Headers
API key
Body
Customer ID
"cust_abc123"
Wallet address
"0x1234567890abcdef1234567890abcdef12345678"
Existing counterparty ID for third-party recipient wallets. If not provided, we'll upsert a new counterparty.
"cp_abc123"
Supported chains
ETHEREUM, BASE, POLYGON, SOLANA, TRON, BITCOIN, ARBITRUM, ROBINHOOD ["ETHEREUM", "BASE"]
Supported currencies
["USDC", "USDT"]
Client-provided external reference for mapping to your system (UUID v4 or CUID recommended)
"550e8400-e29b-41d4-a716-446655440000"
Whether this account belongs to a third party (not the customer). Defaults to false.
false
Wallet custody type used for provider custodian mapping. Defaults to SELF_HOSTED.
SELF_HOSTED, ANCHORAGE, BINANCE, BITGO, CIRCLE, COINBASE, FIREBLOCKS, GEMINI, KRAKEN, ROBINHOOD, OTHER_EXCHANGE "SELF_HOSTED"
Custom metadata for your application
Show child attributes
Show child attributes
{ "nickname": "Primary USDC Wallet" }
Beneficiary type for third-party recipients. Required when creating a new third-party counterparty.
INDIVIDUAL, BUSINESS "INDIVIDUAL"
Beneficiary legal name for third-party recipients. Required when creating a new third-party counterparty.
"Jane Doe"
Beneficiary address for third-party recipient wallets. Required when creating a new third-party counterparty.
Show child attributes
Show child attributes
Response
External wallet created and submitted for async review
Account ID
"ewa_1234567890abcdef"
Customer ID
"cust_abc123"
Account type
EXTERNAL_WALLET "EXTERNAL_WALLET"
Account status
IN_REVIEW, ACTIVE, CLOSED "IN_REVIEW"
Wallet address
"0x1234567890abcdef1234567890abcdef12345678"
Wallet address type
EVM, TRON, BITCOIN, SOLANA "EVM"
Account creation date
"2026-01-15T10:00:00Z"
Account last update date
"2026-01-15T10:00:00Z"
Counterparty ID when this is a third-party recipient wallet
"cp_abc123"
Custom metadata for your application, including account nickname
Show child attributes
Show child attributes
Supported blockchain chains
ETHEREUM, BASE, POLYGON, SOLANA, TRON, BITCOIN, ARBITRUM, ROBINHOOD ["ETHEREUM", "BASE"]
Supported currencies
["USDC", "USDT"]
Wallet custody type used for provider custodian mapping.
SELF_HOSTED, ANCHORAGE, BINANCE, BITGO, CIRCLE, COINBASE, FIREBLOCKS, GEMINI, KRAKEN, ROBINHOOD, OTHER_EXCHANGE "SELF_HOSTED"
Whether this account was newly created in this request or returned from an existing match
true
Was this page helpful?